#!/bin/bash

setup_imx219(){
    IMX219_CAM_FMT='[fmt:SRGGB8_1X8/640x480 field: none]' 

    i=0
    for media_id in {0..1}; do
    # UB953 FORMATS
    UB960_FMT_STR="["
    CSI2RX_FMT_STR="["
    for name in `media-ctl -d $media_id -p | grep entity | grep imx219 | cut -d ' ' -f 5`; do

        CAM_SUBDEV=`media-ctl -d $media_id -p -e "imx219 $name" | grep v4l-subdev | awk '{print $4}'`
        # v4l2-ctl -d $CAM_SUBDEV --set-ctrl wide_dynamic_range=0
	    CAMNAME=''"\"imx219 $name\""''
	    media-ctl -d $media_id --set-v4l2 ''"$CAMNAME:0 [fmt:SRGGB8_1X8/640x480]"''
	    UB953_NAME=`media-ctl -d $media_id -p -e "imx219 $name" | grep ub953 | cut -d "\"" -f 2`
        media-ctl -d $media_id -V "'$UB953_NAME':0 $IMX219_CAM_FMT"
        UB960_NAME=`media-ctl -d $media_id -p -e "$UB953_NAME" | grep ub960 | cut -d "\"" -f 2`
        UB960_PAD=`media-ctl -d $media_id -p -e "$UB953_NAME" | grep ub960 | cut -d : -f 2 | awk '{print $1}'`
        CSI_BRIDGE_NAME=`media-ctl -d $media_id -p -e "$UB960_NAME" | grep csi-bridge | cut -d "\"" -f 2`
        CSI2RX_NAME=`media-ctl -d $media_id -p -e "$CSI_BRIDGE_NAME" | grep "ticsi2rx\"" | cut -d "\"" -f 2`
        CSI2RX_CONTEXT_NAME="$CSI2RX_NAME context $UB960_PAD"

        if [ "$UB960_FMT_STR" != "[" ]; then
                UB960_FMT_STR="${UB960_FMT_STR}, "
                CSI2RX_FMT_STR="${CSI2RX_FMT_STR}, "
        fi
        UB960_FMT_STR="${UB960_FMT_STR}${UB960_PAD}/0 -> 4/${UB960_PAD} [1]"
        CSI2RX_FMT_STR="${CSI2RX_FMT_STR}0/${UB960_PAD} -> $(($UB960_PAD+1))/0 [1]"

        echo "IMX219 Camera $i detected"
        echo "    device = "`media-ctl -d $media_id -p -e "$CSI2RX_CONTEXT_NAME" | grep video | awk '{print $4}'`
        echo "    name = IMX219 $name"
        echo "    format = $IMX219_CAM_FMT"
        echo "    subdev_id = $CAM_SUBDEV"
        echo "    isp_required = yes"
        echo "    ldc_required = yes"

        ((i++))
    done

    UB960_FMT_STR="${UB960_FMT_STR}]"
    CSI2RX_FMT_STR="${CSI2RX_FMT_STR}]"

    media-ctl -d $media_id -p | grep entity | grep imx219 -q
    if [ "$?" == "0" ]; then
    # UB960 ROUTING & FORMATS
    media-ctl -d $media_id -R "'$UB960_NAME' $UB960_FMT_STR"
    for name in `media-ctl -d $media_id -p | grep entity | grep imx219 | cut -d ' ' -f 5`; do
        UB953_NAME=`media-ctl -d $media_id -p -e "imx219 $name" | grep ub953 | cut -d "\"" -f 2`
        UB960_NAME=`media-ctl -d $media_id -p -e "$UB953_NAME" | grep ub960 | cut -d "\"" -f 2`
        UB960_PAD=`media-ctl -d $media_id -p -e "$UB953_NAME" | grep ub960 | cut -d : -f 2 | awk '{print $1}'`
        media-ctl -d $media_id -V "'$UB960_NAME':$UB960_PAD $IMX219_CAM_FMT"
    done

    # CSI2RX ROUTING
    media-ctl -d $media_id -R "'$CSI2RX_NAME' $CSI2RX_FMT_STR"
    fi
    done
}

ls /sys/class/video4linux/ | grep v4l-subdev -q
if [ "$?" == "0" ]; then
    cat /sys/class/video4linux/v4l-subdev*/name | grep imx219 -q
    if [ "$?" == "0" ]; then
        setup_imx219
    fi
fi

